"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var url_join_1 = __importDefault(require("url-join"));
var jira = /\[?([\w]{3,}-\d+)\]?:?\s?[-\s]*([\S ]+)?/;
function parseJira(commit) {
    // Support 'JIRA-XXX:' and '[JIRA-XXX]' and '[JIRA-XXX] - '
    var matches = [];
    var currentMatch = commit.subject.match(jira);
    while (currentMatch) {
        matches.push(currentMatch);
        var rest = currentMatch[2];
        if (!rest) {
            break;
        }
        currentMatch = rest.match(jira);
    }
    if (!matches.length) {
        return commit;
    }
    return __assign({}, commit, { jira: {
            number: matches.map(function (match) { return match[1]; })
        } });
}
exports.parseJira = parseJira;
var JiraPlugin = /** @class */ (function () {
    function JiraPlugin(options) {
        this.name = 'Jira';
        this.options = typeof options === 'string' ? { url: options } : options;
    }
    JiraPlugin.prototype.apply = function (auto) {
        var _this = this;
        auto.hooks.onCreateChangelog.tap(this.name, function (changelog) {
            changelog.hooks.renderChangelogLine.tap(_this.name, function (_a) {
                var _b = __read(_a, 2), commit = _b[0], currentRender = _b[1];
                var line = currentRender;
                var jiraCommit = parseJira(commit);
                if (jiraCommit.jira && _this.options.url) {
                    var link = url_join_1.default.apply(void 0, __spread([_this.options.url], jiraCommit.jira.number));
                    var _c = __read(commit.subject.match(jira), 3), rest = _c[2];
                    line = line.replace(jira, "[" + jiraCommit.jira.number + "](" + link + ")" + (rest ? ':' : '') + " $2");
                }
                return [commit, line];
            });
        });
    };
    return JiraPlugin;
}());
exports.default = JiraPlugin;
//# sourceMappingURL=index.js.map